/////////////////////////////////////////////////////////////////////////////
// Name:        ThankYouPage.cpp
// Purpose:     Wizard page for making the user feel good
// Author(s):   Atul, Ashesh
// Created:     2008-07-08
// RCS-ID:      $Id: ThankYouPage.cpp,v 1.9 2008/08/18 14:18:35 asheshv Exp $
// Copyright:   (c) EnterpriseDB
/////////////////////////////////////////////////////////////////////////////

#include "TuningTool.h"

// wxWindows headers
#include <wx/wx.h>
#include <wx/busyinfo.h>
#include <wx/utils.h>
#include <wx/wizard.h>
#include <wx/gbsizer.h>

#ifdef __WXMSW__
#include <wx/msw/registry.h>
#endif

// Application headers
#include "ThankYouPage.h"

extern const char * Tuning_xpm[];

BEGIN_EVENT_TABLE(ThankYouPage, wxWizardPageSimple)
    EVT_WIZARD_PAGE_CHANGING(wxID_ANY, ThankYouPage::OnWizardPageChanging)
END_EVENT_TABLE()

ThankYouPage::ThankYouPage(wxWizard *parent)
    : wxWizardPageSimple(parent)
{
    SetBackgroundColour(*wxWHITE);
    wxBoxSizer *mainSizer = new wxBoxSizer(wxVERTICAL);
    mainSizer->Add(0, 10);
    wxStaticText *st = new wxStaticText(this, wxID_ANY, 
        wxT("Your new PostgreSQL configuration file has been saved."));
    st->Wrap(400);
    mainSizer->Add(st, 0, wxALL, 5);
    mainSizer->Add(0, 10);

    st = new wxStaticText(this, wxID_ANY, 
        wxT("Please restart the PostgreSQL service to enable the changes."));
    wxFont boldDflFont = st->GetFont();
    boldDflFont.SetWeight(wxFONTWEIGHT_BOLD);
    st->SetFont(boldDflFont);
    st->Wrap(400);
    mainSizer->Add(st, 0, wxALL, 5);

    mainSizer->Add(0, 10);

    st = new wxStaticText(this, wxID_ANY, 
        wxT("Thank you for using the EnterpriseDB Tuning Wizard."));
    st->Wrap(400);
    mainSizer->Add(st, 0, wxALL, 5);
    
    m_additionalInfo = new wxCheckBox(this, wxID_ANY,
        wxT("Display additional information about EnterpriseDB services"));
    m_additionalInfo->SetValue(true);
    mainSizer->Add(m_additionalInfo, 0, wxALL, 5);
    mainSizer->AddStretchSpacer();
    wxGridBagSizer *imageSizer = new wxGridBagSizer();
    imageSizer->SetMinSize(15, 5);
#if wxUSE_STATBMP
    wxBoxSizer *bmpSizer = new wxBoxSizer(wxVERTICAL);
    imageSizer->Add(
        bmpSizer, wxGBPosition(0,32), wxGBSpan(3,1), wxALIGN_RIGHT
        );
    // Create and run the wizard
    wxBitmap bitmap = wxBitmap(Tuning_xpm);
    if ( bitmap.Ok() )
    {
        wxStaticBitmap *statbmp = new wxStaticBitmap(this, wxID_ANY, bitmap);
        bmpSizer->Add(statbmp, 0, wxALL, 0);
    }
#endif
    mainSizer->Add(imageSizer);
    SetSizer(mainSizer);
    mainSizer->Fit(this);
}

void ThankYouPage::OnWizardPageChanging(wxWizardEvent& event)
{
    // Do any checking here, before the page changes
    return;
}
