/////////////////////////////////////////////////////////////////////////////
// Name:        CompletionPage.h
// Purpose:     Completion page of the wizard
// Author(s):   Atul, Ashesh
// Created:     2008-07-08
// RCS-ID:      $Id: CompletionPage.h,v 1.3 2008/08/29 12:00:54 asheshv Exp $
// Copyright:   (c) EnterpriseDB
/////////////////////////////////////////////////////////////////////////////

#ifndef _COMPLETIONPAGE_H
#define _COMPLETIONPAGE_H

#include "TuningTool.h"
#include "Wizard.h"

// wxWindows headers
#include <wx/wx.h>
#include <wx/wizard.h>
#include <wx/button.h>

class CompletionPage;

struct ConfigLine{
private:
    static void GenerateNext(ConfigLine*& current, ConfigLine*& prev);
    ConfigLine();
    wxString m_aLine;
    bool m_isModified;
    ConfigLine *m_next;
    int m_parameter;
    wxString m_original_value;
    bool m_isComment;
    wxString m_buffer;
    friend class CompletionPage;
};

class CompletionPage : public wxWizardPageSimple
{
public:
    CompletionPage(wxWizard *parent);
    virtual void OnWizardPageChanging(wxWizardEvent& event);
	ConfigLine* GetPostgreSQLConfiguration();

private:
	Wizard *m_parent;
	wxString m_backupFileName;
	// m_backedup takes care of preventing multiple times backups
	bool m_backedup;
	
	void OnReview(wxCommandEvent& event);
	wxString BackupConfFile();
    void UpdateConfFile(wxString backupFileName);
    void InitProgressBar(bool show);
    void UpdateProgressBar(wxString status, int increaseBy = 1);

    int m_current_progress_value;

	wxButton *m_review;
    wxProgressDialog *m_progressDlg;
	DECLARE_EVENT_TABLE()
};

#endif
