/////////////////////////////////////////////////////////////////////////////
// Name:        FileSelectorCombo.h
// Purpose:     File Selector combobox
// Author(s):   Atul, Ashesh
// Created:     2008-07-08
// RCS-ID:      $Id: FileSelectorCombo.h,v 1.2 2008/08/18 14:18:35 asheshv Exp $
// Copyright:   (c) EnterpriseDB
/////////////////////////////////////////////////////////////////////////////

#ifndef _FILESELECTORCOMBO_H
#define _FILESELECTORCOMBO_H

#include "TuningTool.h"

// wxWindows headers
#include <wx/wx.h>
#include <wx/wizard.h>
#include <wx/button.h>
#include <wx/combo.h>

// ----------------------------------------------------------------------------
// wxComboCtrl with entirely custom button action (opens file dialog)
// ----------------------------------------------------------------------------

class FileSelectorCombo : public wxComboCtrl
{
public:
    FileSelectorCombo() : wxComboCtrl() { Init(); }

	FileSelectorCombo(wxWindow *parent,
		wxWindowID id = wxID_ANY,
		const wxString& value = wxEmptyString,
		const wxPoint& pos = wxDefaultPosition,
		const wxSize& size = wxDefaultSize,
		long style = 0,
		const wxValidator& validator = wxDefaultValidator,
		const wxString& name = wxComboBoxNameStr);
    virtual void OnButtonClick();

    // Implement empty DoSetPopupControl to prevent assertion failure.
	virtual void DoSetPopupControl(wxComboPopup* WXUNUSED(popup)) {}
	wxString GetFilename() const {return m_filename;}
	wxString GetDirectory() const {return m_directory;}
	wxString GetPath() const {return m_path;}

private:
	wxFileDialog* m_filedlg;
	wxString m_filename;
	wxString m_directory;
	wxString m_path;
	void Init() {}
};

#endif

