/////////////////////////////////////////////////////////////////////////////
// Name:        WsUtils.h
// Purpose:     Utility class for working with dynatune webservice
// Author(s):   Atul, Ashesh
// Created:     2008-07-08
// RCS-ID:      $Id: WSUtils.h,v 1.3 2008/08/18 14:18:35 asheshv Exp $
// Copyright:   (c) EnterpriseDB
/////////////////////////////////////////////////////////////////////////////

#ifndef _WSUTILS_H
#define _WSUTILS_H

#include "soapAuthenticationServiceSoapBindingProxy.h"

struct RSData{
    char *prop;
    char *value;
    ~RSData();
    RSData();
};
typedef struct RSData ResultData;
#define DYNATUNE_CONFIG_LEN 17

class WSUtils {
public:
    static ResultData *GetDynatuneInfo(
    AuthenticationServiceSoapBindingProxy& authBody,
        wxString &uuid, wxString &server_utilization, 
        wxString &workload_profile, int& len);
    static int validateUser(AuthenticationServiceSoapBindingProxy& authBody,
        wxString &uuid, wxString &db_version, wxString &userid,
        wxString &passwd, wxString &server_util, wxString &work_prof);
	static char* Genguid();
	static void Releaseguid();
private:
    static char HexCharToChar(char c);
	static int IsAllHex(const char* const must_be_hex);
	static char *ConvertToHexString(const char *str);
	static char *HexStrToStr(const char *str);
	static char *GetTotalMemoryInGB();
	static char *GetTotalMemoryInMB();
	static char* GetLocaleName();
};

#endif // _WSUTILS_H

